/* config.h: master configuration file, included first by all compilable
   source files (not headers).  */

#ifndef CONFIG_H
#define CONFIG_H

/* The stuff from the path searching library.  */
#include <kpathsea/config.h>

#include <setjmp.h>

#ifndef HAVE_VPRINTF
#ifdef HAVE_DOPRNT
#define	vfprintf(stream, message, args)	_doprnt(message, args, stream)
/* If we have neither, should fall back to fprintf with fixed args.  */
#endif
#endif

/* Some xdvi options we want by default.  */
#define USE_PK
#define USE_GF
#ifndef NOSELFILE
#define SELFILE
#endif
#ifndef NOBUTTONS
#define BUTTONS
#endif
#ifndef NOGREY
#define GREY
#endif
#ifndef NOTEXXET
#define TEXXET
#endif
#ifdef NOMAKEPK
#define MAKEPK_BY_DEFAULT_STRING "false"
#define MAKEPK_BY_DEFAULT_BOOL False
#else
#define MAKEPK_BY_DEFAULT_STRING "true"
#define MAKEPK_BY_DEFAULT_BOOL True
#endif

#define KANJI
#ifdef  NOZEIT
#define ASCIIDNP
#else /* !NOZEIT */
#define USE_ZEIT
#define DEFAULT_FONTCONF ""
#ifndef NOVFONTMAP
#define USE_VFONTMAP
#define DEFAULT_FONTMAP "/usr/local/lib/texmf/xdvi/vfontmap"
#endif /* NOVFONTMAP */
#ifndef NONTTZEIT
#define NTTZEIT
#endif /* NONTTZEIT */
#endif /* NOZEIT */

#ifndef NOTOC
#define TOC
#define MAX_PAGE 1024
#endif
#ifndef NOPAGENUM
#define PAGENUM
#endif
#ifndef NOMARKPAGE
#define MARKPAGE
#define RINGSIZE 1024
#endif
#ifndef NOPRINTDVI
#define PRINTDVI
#define DVIPS
/* Print-out command templates */
/* all pages of DVI file */
#define PRCMDALL "cd %d; dvips -f -q %F | %P"
/* the current page */
#define PRCMDCUR "cd %d; dvips -f -q -p=%c -l=%c %F | %P"
/* the lastly marked page */
#define PRCMDMRK "cd %d; dvips -f -q -p=%m -l=%m %F | %P"
/* pages in the region, between the current page and the lastly marked page */
#define PRCMDRGN "cd %d; dvips -f -q -p=%s -l=%e %F | %P"
/* all marked pages */
#define PRCMDLST "cd %d; dvips -f -q -pp %o %F | %P"

/* the default printer to print-out DVI file */
#define DVIPRINTER "lp"
/* work directory for temporal files */
#define TEMPDIR "/tmp"
/* DVI filter command string */
/* translation file from xdvi paper type into dvi filter paper size option */
#ifdef DVIPS
#define DVIFILTERCMD "dvips -t %Z"
#define FILTOPTTBLFILE  "/usr/local/lib/texmf/xdvi/xdvipaper.dvips"
#else /* ! DVIPS */
#ifdef JDVI2KPS
#define DVIFILTERCMD "jdvi2kps -pa %Z"
#define FILTOPTTBLFILE  "/usr/local/lib/texmf/xdvi/xdvipaper.jdvi2kps"
#else /* ! JDVI2KPS */
#define DVIFILTERCMD "dvi2ps -o %Z"
#define FILTOPTTBLFILE  "/usr/local/lib/texmf/xdvi/xdvipaper.dvi2ps-j"
#endif /* JDVI2KPS */
#endif /* DVIPS */
/* print command string */
#define PRINTCMD "lpr -s -r -P%p"
#endif /* NOPRINTDVI */
#ifndef NOPAPERMENU
#define PAPERMENU
#endif

/* for FreeBSD by Hitoshi Hagiwara(hitoshi@tuat.ac.jp) */
/* modified for Linux by Takanori Uchiyama(uchiyama@bacchus.in.kobe-u.ac.jp) */
/* modified for BSD/OS by S.Hagihira */
/* modified for NetBSD by S.Taniguchi */
#if defined(__FreeBSD__) || defined(linux) || defined(__bsdi__) || defined(__NetBSD__)
#define FOIL_X_WCHAR_T
#endif

/* xdvi's definitions.  */
#include "xdvi.h"

#endif /* not CONFIG_H */
