/*
     Copyright (C) 1996 - 1997  Masahito Yamaga (yamaga@ipc.chiba-u.ac.jp)
*/

#include "config.h"
#include <sys/param.h>	/* for MAXPATHLEN */

char **jfnames;
char **vfnames;
int n_map_entry=0;

#define	MAX_VFONTS	255
#define	MAX_VFONTNAME	127

void addfontmap(s1,s2,i)
	char *s1,*s2;
	int i;
{
	char *p;

	if (p=(char *)xmalloc(strlen(s1)+1,"Japanese font name entry")){
		strcpy(p,s1);
		jfnames[i]=p;
	}
	if (p=(char *)xmalloc(strlen(s2)+1,"Vector font name entry")){
		strcpy(p,s2);
		vfnames[i]=p;
	}
}

read_VFontmap()
{
	FILE *map;
	char vfontmapf[MAXPATHLEN], line[BUFSIZ];
	char fname[MAX_VFONTNAME+1], vfname[MAX_VFONTNAME+1];
	int i, nfn, nvfn, fn, vfn, min, nmin, tmin, goth, ngoth, tgoth, dm, dg;

	min=nmin=tmin=goth=ngoth=tgoth=dm=dg=0;

	jfnames = (char **)xmalloc((MAX_VFONTS+1)*sizeof(char *),
				"Table of Japanese font names");
	vfnames = (char **)xmalloc((MAX_VFONTS+1)*sizeof(char *),
				"Table of vector font names");

#define ADDFONTMAP(x,y) addfontmap(x,y,++n_map_entry)

#if defined(USE_ZEIT) && defined(USE_VFONTMAP)

#ifndef	DEFAULT_FONTMAP
#define	DEFAULT_FONTMAP	"/usr/local/lib/texmf/xdvi/vfontmap"
#endif

	if (strcmp(resource.vfontmap,DEFAULT_FONTMAP))
		strcpy(vfontmapf, resource.vfontmap);
	else
	if (getenv("VFONTMAP"))
		strcpy(vfontmapf, getenv("VFONTMAP"));
	else
		strcpy(vfontmapf, DEFAULT_FONTMAP);

	if (!(map =  fopen(vfontmapf, "r"))) {
		Fprintf(stderr,"Warning: Can't open \"%s\"\n",vfontmapf);
		Fprintf(stderr,"         Default Values are Used.\n");
	} else {
		while(fgets(line, BUFSIZ, map)){
			nfn=nvfn=0;
			fn=1;vfn=0;
			for(i=0;line[i]!='\n' && line[i]!='#';i++){
				if (line[i]!=' '&& line[i]!='\t') {
					if (fn) fname[nfn++]=line[i];
					if (vfn) vfname[nvfn++]=line[i];
				} else {
					if (fn && nfn) {fn=0;vfn=1;}
				}
			}
			if (!i || !nfn) continue;
			fname[nfn]='\0';
			if (nvfn) vfname[nvfn]='\0';
			else {
			Fprintf(stderr, "No specified Vector Font name for \"%s\"\n", fname);
			continue;
			}
			ADDFONTMAP(fname,vfname);
			if (!strcmp(fname,"min")) min=1;
			if (!strcmp(fname,"nmin")) nmin=1;
			if (!strcmp(fname,"tmin")) tmin=1;
			if (!strcmp(fname,"goth")) goth=1;
			if (!strcmp(fname,"ngoth")) ngoth=1;
			if (!strcmp(fname,"tgoth")) tgoth=1;
			if (!strcmp(fname,"dm")) dm=1;
			if (!strcmp(fname,"dg")) dg=1;
		}
	}
#endif /* USE_ZEIT && USE_VFONTMAP */

	if (!min) 	ADDFONTMAP("min","min");
	if (!nmin)	ADDFONTMAP("nmin","min");
	if (!tmin)	ADDFONTMAP("tmin","min");
	if (!goth)	ADDFONTMAP("goth","goth");
	if (!ngoth)	ADDFONTMAP("ngoth","goth");
	if (!tgoth)	ADDFONTMAP("tgoth","goth");
	if (!dm)	ADDFONTMAP("dm","min");
	if (!dg)	ADDFONTMAP("dg","goth");
}
